/* 

Example Encrypted GameSpy IRC Session
by xoclipse
xoclipse@cox.net
web: http://xoclipse.fraghosts.net

This program will connect to the IRC, set your nickname, and join
#count_updates channel. That is the default channel all GSA Clients
join.

*/
#include <stdio.h>
#include "gsirc.h"

#define win32

#ifdef win32

#pragma comment(lib, "ws2_32.lib")
#include <winsock.h>
#include <windows.h>
#define close closesocket

#else

#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#endif


#define CRYPT "CRYPT des 1 gslive\r\n"
#define MAXBUFSIZE 1024
#define IRC_PORT 6667
#define HOST "peerchat.gamespy.com"
#define USER_COMMAND "USER XaaaaaaaaX|%d 127.0.0.1 peerchat.gamespy.com :%s\x0d\x0a"
#define NICK_COMMAND "NICK %s\r\n"

void parse(char *buf, int length);
char *nick; //users nick
int id; //users id

int sockfd;

int main(int argc, char *argv[])
{	
int ret;
struct sockaddr_in remote;
char *buf = new char[MAXBUFSIZE];
struct hostent *host;

if(argc != 3) {
	printf("\nGameSpy Arcade Encrypted IRC Login\n"\
		   "by xoclipse\n"\
		   "web: xoclipse @cox.net\n"\
		   "usage: %s nickname profileid\n\n", argv[0]);
	exit(1);
}

nick = argv[1];
id = atoi(argv[2]);

#ifdef win32
WSAData wsad;
WSAStartup(MAKEWORD(1,1), &wsad);
#endif

//try to resolve gpsp.gamespy.com
if((host = gethostbyname(HOST)) == NULL) {
	perror("Couldn't resolve hostname");
	exit(1);
}

//allocate a socket
sockfd = socket(AF_INET, SOCK_STREAM, IPPROTO_IP);

remote.sin_family = AF_INET; //always AF_INET
remote.sin_port = htons(IRC_PORT);
remote.sin_addr = *((struct in_addr*)host->h_addr);

connect(sockfd, (struct sockaddr*)&remote, sizeof(remote));

send(sockfd, CRYPT, strlen(CRYPT), 0);

while(1) {
	ret = recv(sockfd, buf, MAXBUFSIZE, 0);
	buf[ret] = 0;
	if(ret <= 0) {
		printf("host closed conenction\n");
		exit(1);
	}
	else
	{
	parse(buf, ret);
	}
}
	return 0;
}
//-------------------------------------------------------------------
void parse(char *buf, int length)
{
	int ret;
	if(strncmp(buf, ":s 705",6) == 0) { //here's our keys
		buf += 9;
		memcpy(key, buf, 16);
		memcpy(key1, buf+17, 16);
		initbuffer();
		char *id = encrypt("USRIP\r\n", 7);
		send(sockfd, id, 7, 0);
		printf("Session running in encrypted mode...\n\n");
	}
	else
	{
		char *stuff = decrypt(buf, length);
		if(strncmp(stuff, ":s 302", 6) == 0) { //ready to send user/nick commands
			char user[512];
			ret = sprintf(user, USER_COMMAND, id, "c6b9082e929dda830f0a3cbf721891d6");
			user[ret] = 0;
			char *pck = encrypt(user, ret);
			send(sockfd, pck, ret, 0);
			ret = sprintf(user, NICK_COMMAND, nick);
			user[ret] = 0;
			char *pck1 = encrypt(user, ret);
			send(sockfd, pck1, ret, 0);

		}
		else if(strncmp(stuff, "PING :s", 7) == 0) {
			char *pong = encrypt("PONG :s\x0d\x0a", 9);
			send(sockfd, pong, 9, 0);
		}
		else if(strncmp(stuff, ":s 002",6) == 0) {
			char *join = encrypt("JOIN #count_updates \x0d\x0a",22);
			send(sockfd, join, 22, 0);
		}
	}
	
}