/* 
GameSpy Arcade IRC Algorithms
by xoclipse
email: xoclipse@cox.net
web: http://xoclipse.fraghosts.net
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

unsigned char key[17];
unsigned char key1[17];
char buffer[256];
char buffer1[256];
char middle[2];
char middle1[2];

//prototype functions
void initbuffer(); //initialize keys into buffer
char *encrypt(char *data, int length); //encrypt data
char *decrypt(char *data, int length); //decrypt data

char *encrypt(char *data, int length)
{
unsigned int ecx, edx, esi, edi, ebx;
unsigned int temp; //ebp+10
unsigned int temp1; //ebp-4
unsigned int temp2; //ebp-8
char *stuff = new char[length];
memcpy(stuff, data, length);
ecx = 0; 
ecx = middle1[0] & 0xFF;
esi = middle1[1] & 0xFF; 
edi = 0;
ebx = length;

//LOOP
for(int x = 0; x < length; x++)
{
ecx++;

if(!(ecx &= 0x800000FF)) {
	ecx--;
	ecx |= 0xFFFFFF00;
	ecx++;
}

temp = ecx;
ecx = temp;
ecx &= 0x0FF;
edx = buffer[ecx]&0xFF;
ebx = edx;
ebx &= 0x0FF;
ebx += esi;


if(!(ebx &= 0x800000FF)) {
	ebx--;
	ebx |= 0xFFFFFF00;
	ebx++;
}

temp1 = ebx;
temp2 = edx;
esi = temp1;
esi &= 0x0FF;
ebx = buffer[esi];
buffer[ecx] = ebx;
ebx = temp2;
buffer[esi] = edx;
edx = 0;
edx = buffer[ecx];
ebx &= 0x0FF;
edx += ebx;

if(!(edx &= 0x800000FF)) {
	edx--;
	edx |= 0xFFFFFF00;
	edx++;
}

edx &= 0xFF;
ebx = buffer[edx&0xFF]&0xFF;
edx = temp2;

stuff[edi] ^= ebx;
edx = length;
edi++;
}
ecx = temp;
edx = temp1;
middle1[0] = ecx;
middle1[1] = edx;
return stuff;
}

char *decrypt(char *data, int length)
{
unsigned int ecx, edx, esi, edi, ebx;
unsigned int temp; //ebp+10
unsigned int temp1; //ebp-4
unsigned int temp2; //ebp-8
char *stuff = new char[length];
memcpy(stuff, data, length);
ecx = 0; 
ecx = middle[0] & 0xFF;
esi = middle[1] & 0xFF; 
edi = 0;
ebx = length;

//LOOP
for(int x = 0; x < length; x++)
{
ecx++;

if(!(ecx &= 0x800000FF)) {
	ecx--;
	ecx |= 0xFFFFFF00;
	ecx++;
}

temp = ecx;
ecx = temp;
ecx &= 0x0FF;
edx = buffer1[ecx]&0xFF;
ebx = edx;
ebx &= 0x0FF;
ebx += esi;


if(!(ebx &= 0x800000FF)) {
	ebx--;
	ebx |= 0xFFFFFF00;
	ebx++;
}

temp1 = ebx;
temp2 = edx;
esi = temp1;
esi &= 0x0FF;
ebx = buffer1[esi];
buffer1[ecx] = ebx;
ebx = temp2;
buffer1[esi] = edx;
edx = 0;
edx = buffer1[ecx];
ebx &= 0x0FF;
edx += ebx;

if(!(edx &= 0x800000FF)) {
	edx--;
	edx |= 0xFFFFFF00;
	edx++;
}

edx &= 0xFF;
ebx = buffer1[edx&0xFF]&0xFF;
edx = temp2;

stuff[edi] ^= ebx;
edx = length;
edi++;
}
ecx = temp;
edx = temp1;
middle[0] = ecx;
middle[1] = edx;
for(int x = 0; x < length;x++) printf("%c", (unsigned char)stuff[x]);
printf("\n\n");
return stuff;

}
//----------------------------------------------------------------
void initbuffer()
{
unsigned int ecx, edx, edi, ebx, eax;
unsigned int temp; //ebp+10
unsigned int temp1; //ebp-4
unsigned int temp2; //ebp-8
unsigned int temp3; //ebp+c
unsigned int wtf; //eax+ebx
char *ptr;
char hash[7] = "Xn221z";
hash[6] = 0;
key1[16] = 0;
key[16] = 0;
middle[0] = 0x00;
middle[1] = 0x00;
middle1[0] = 0;
middle1[1] = 0;
ptr = hash;
ecx = 0;
for(int x = 0; x < 16; x++)
{
ebx = *ptr;
key[ecx] ^= ebx;
ptr++;
if(*ptr == 0) ptr = hash;
ecx++;
}
//2nd key
ptr = hash;
ecx = 0;
for(int x = 0; x < 16; x++)
{
ebx = *ptr;
key1[ecx] ^= ebx;
ebx = *ptr++;
if(*ptr == 0) ptr = hash;
ecx++;
}

/* Initial?? */


for(int x = 0; x < 256; x++) buffer[x] = 255-x;
for(int x = 0; x < 256; x++) buffer1[x] = 255-x;

ecx = 0;
eax = 256;
edi = 0;
temp1 = ecx;
temp3 = 0x10;

//LOOP
for(int x = 0; x < 256; x++)
{
eax = temp1;
edx = buffer[edi]&0xFF;
eax &= 0x0FF;
temp = edx&0xFF;
edx = 0;
edx = key[eax];



ebx = temp;
ebx &= 0x0FF;
ecx += edx;
ebx += ecx;


if(!(ebx &= 0x800000FF)) {
	ebx--;
	ebx |= 0xFFFFFF00;
	ebx++;
}

temp2 = ebx;
ecx = temp2;
ecx &= 0x0FF;
eax++;
edx = buffer[ecx]&0xFF;
buffer[edi] = edx;
edx = temp;

buffer[ecx] = edx;
//CDQ?
if (eax < 0x80000000) {
	edx = 0;
}
else {
	edx = 0xFF;
}

temp = eax / temp3;
edx = eax % temp3;
eax = temp;

edi++;
temp1 = edx&0xFF;
}

/*	calculate second buffer */

ecx = 0;
eax = 256;
edi = 0;
temp1 = ecx;

temp3 = 0x10;

//LOOP
for(int x = 0; x < 256; x++)
{
eax = temp1;
edx = buffer1[edi]&0xFF;
eax &= 0x0FF;
temp = edx&0xFF;
edx = 0;
edx = key1[eax];



ebx = temp;
ebx &= 0x0FF;
ecx += edx;
ebx += ecx;


if(!(ebx &= 0x800000FF)) {
	ebx--;
	ebx |= 0xFFFFFF00;
	ebx++;
}

temp2 = ebx;
ecx = temp2;
ecx &= 0x0FF;
eax++;
edx = buffer1[ecx]&0xFF;
buffer1[edi] = edx;
edx = temp;

buffer1[ecx] = edx;
//CDQ?
if (eax < 0x80000000) {
	edx = 0;
}
else {
	edx = 0xFF;
}

temp = eax / temp3;
edx = eax % temp3;
eax = temp;

edi++;
temp1 = edx&0xFF;
}

}

//-------------------------------------------------------------------